	LIST 	P=16F84
PORTA	EQU	h'05'
PORTB 	EQU	h'06'
STATUS	EQU	h'03'
TRISA	EQU	h'85'
TRISB	EQU	h'86'
WAITF	EQU	h'0E'
FH1	EQU	h'20'
FH8	EQU	h'21'
FHD	EQU	h'22'
FH2	EQU	h'23'
	CLRF	PORTB		;PORTB ieriini 0 yap
	BSF	STATUS, 5	;BANK1 e ge
	CLRF	TRISB		;PORTB k yap
	MOVLW	h'FE'		;W registerine h'FF' ykle
	MOVWF	TRISA		;PORTA y giri 0 HARIC
	BCF	STATUS, 5	;BANK0 ge
;------------------------reset-----------------------------------
RESET	CLRF	PORTB
	CLRF	FH1
	CLRF	FHD
	MOVLW	h'4B'
	MOVWF	WAITF
	MOVLW	h'05'
	MOVWF	FH8
;--------------------ilk-sinyal----------------------------------
SGNWT	BSF	PORTA, 0
	BTFSS	PORTA, 1
	GOTO	SGNWT
	BCF	PORTA, 0
;--------------------------kaydr---------300us------------------------
	MOVLW	h'64'
	MOVWF	FH1
KAYDIR	DECFSZ	FH1, F
	GOTO 	KAYDIR
;-----------------------------------------------------------------
;				START BIT
;-----------------------------------------------------------------------
	BTFSS	PORTA, 1
	GOTO	RESET
	CALL 	WAIT
	DECFSZ	WAITF, F
	BTFSS	PORTA, 1
	GOTO	RESET
	CALL 	WAIT
	DECFSZ	WAITF, F
	BTFSS	PORTA, 1
	GOTO	RESET
	CALL 	WAIT
	DECFSZ	WAITF, F
	BTFSS	PORTA, 1
	GOTO	RESET
	CALL 	WAIT
	DECFSZ	WAITF, F
	BTFSC	PORTA, 1
	GOTO	RESET
	CALL 	WAIT
	DECFSZ	WAITF, F
;---------------------------------------------------------------------
;				DATA
;---------------------------------------------------------------------
AGAIN	NOP
	NOP			
	CALL 	WAIT
	DECFSZ	WAITF, F
	BTFSS	PORTA, 1
	GOTO	JUMP	
	CALL 	WAIT
	DECFSZ	WAITF, F
	NOP
	NOP	
	CALL 	WAIT
	DECFSZ	WAITF, F
	CALL	YAZ1
	GOTO	CHECK
JUMP	CALL	WAIT
	DECFSZ	WAITF, F
	CALL	YAZ0
CHECK	DECFSZ	FH8, F
	GOTO	AGAIN
;------------------------------------------------------------------
;			DATA->PORTB
;------------------------------------------------------------------
	MOVF	FHD, W
	MOVWF	PORTB	
;------------------------------------------------------------------
TIME	CALL	WAIT
	DECFSZ	WAITF, F
	GOTO	TIME
;----------------------------------------------------------------
	CALL	NEW
	GOTO	RESET
;-----------------------Alt-programlar-----------------------
;		     wait-600us
;-------------------------------------------
WAIT	MOVLW h'02'
	MOVWF FH1
DONGU1
	MOVLW h'64'
	MOVWF FH2
DONGU2
	DECFSZ FH2, F
	GOTO DONGU2
	DECFSZ FH1, F
	GOTO DONGU1			
	RETURN
;------------------------------------------------------
;			1yaz
;---------------------------------------------------
YAZ0	RLF	FHD, F
	BCF	FHD, 0
	RETURN
;---------------------------------------------------------
;			0yaz
;-----------------------------------------------------
YAZ1	RLF	FHD, F
	BSF	FHD, 0
	RETURN
;--------------------------------------------------------
NEW	MOVLW h'F0'
	MOVWF FH1
DONGU11
	MOVLW h'F0'
	MOVWF FH2
DONGU22
	DECFSZ FH2, F
	GOTO DONGU22
	DECFSZ FH1, F
	GOTO DONGU11			
	RETURN
;-------------------------------------------------------
	END
